/*  Codigo final del Pulsimetro 
 *   SET21 Proyecto 2 - Décimo
-------------------------------------------------------------
*/
#include <Adafruit_SSD1306.h>     //Se incluye la librería Adafruit_SSD1306
#define OLED_Address 0x3C        // Define una constante llamada OLED_Address y le da el valor de 0x3C (el cual es una dirección estandar)
Adafruit_SSD1306 oled(128, 64);  // Crea un objeto de pantalla llamado: oled con una resolución de 128x 64 pixeles

int x=0;  //Crea una variable llamada x con un valor de 0
int UltimaX=0;  //Crea una variable llamada UltimaX con un valor de 0
int y;  //Crea una variable llamada y
int UltimaY=0;  //Crea una variable llamada UltimaY con un valor de 0
int TiempoAnterior=0; //Crea una variable llamada TiempoAnterior con un valor de 0
int TiempoActual; //Crea una variable llamada TiempoActual
bool BPMTiming=false; //Crea una variable booleana (es decir, verdadera o falsa) llamada BPMTiming con el valor de falsa
bool BeatComplete=false; //Crea una variable booleana (verdadera o falsa) llamada BeatComplete con el valor de falsa
int BPM=0; //Crea una variable llamada BPM con un valor de 0
int UmbralArriba = 2740; //define una variable llamada UmbralArriba con el valor de 2760
int UmbralAbajo = 2700;  //define una variable llamada UmbralAbajo con el valor de 2720

//Inicia configuración
void setup() { 
  oled.begin(SSD1306_SWITCHCAPVCC, OLED_Address); //inicia el objeto oled y le asigna la dirección contenida en las constante OLED_Address
  oled.clearDisplay(); //limpia la pantalla con la funcion .clearDisplay() 
  Serial.begin(115200); //inicia comunicacion serial
}

//Inicia loop principal
void loop() {
  if(x>127){  //si x es mayor a 127 entonces...
    oled.clearDisplay(); //entonces se limpia la pantalla
    x=0;  
    UltimaX=x;  //UltimaX igual a x
  }

  TiempoActual=millis(); //TiempoActual igual al cronometro interno de la ESP32
  int value=analogRead(33); //value es igual a la lectura del pin 33

  
  //Impresiones para debuggear y calibrar el sensor de pulso en el Serial Plotter:
  Serial.print(value); //envía al serial el valor de value
  Serial.print(" ");
  Serial.print(UmbralArriba); //envía al serial el valor de UmbralArriba
  Serial.print(" ");
  Serial.println(UmbralAbajo); //envía al serial el valor de UmbralAbajo

  //Grafica del sensor de pulso en la pantalla oled
if(value > UmbralArriba){ //si value es mayor a UmbralArriba. 
  //map reasigna un número de un rango a otro. 
  y= map(value, UmbralAbajo-200, UmbralArriba+100, 0, 20); //reasigna value al rango entre 0 y 20. "y" es igual al resultado. 
  //el mapeo anterior lo hacemos para que los valores de "y" esten dentro del tamaño de la pantalla oled
  oled.writeLine(UltimaX,UltimaY,x,y,WHITE);  //dibuja una linea en la pantalla oled equivalente a la lectura del sensor
 }else { //si value no es mayor a UmbralArriba
  y=32; // le damos el valor de 32 a "y" el cual es equivalente a la mitad de la pantalla
  oled.writeLine(UltimaX,UltimaY,x,y,WHITE); //dibuja una linea en la mitad de la pantalla mientras value no supere el umbralArriba
 }
  UltimaY=y;  //UltimaY es igual a "y", es decir que la actualizamos
  UltimaX=x;  //UltimaX es igual a "x", es decir que la actualizamos
  
  // vamos a calcular los BPM (beats per minute o latidos por minuto)
  if(value>UmbralArriba){ ////si value es mayor a UmbralArriba entonces...
  
    if(BeatComplete == true){ //Si BeatComplete es verdadero
      BPM=TiempoActual-TiempoAnterior;  //BPM es igual a TiempoActual menos TiempoAnterior
      BPM=int(60/(float(BPM)/1000));  //Operación para sacar la frecuencia cardiaca
      BPMTiming=false;  //BPMTiming es falso
      BeatComplete=false; //BeatComplete es falso
    }
    if(BPMTiming==false){ //Si BPMTiming es falso entonces...
      TiempoAnterior=millis(); //TiempoAnterior es igual al tiempo actual del cronometro interno de la ESP32 
      BPMTiming=true; //BPMTiming es verdadero
    }
  }
  if(value<UmbralAbajo && BPMTiming == true) { // Si value es menor a UmbralAbajo y también BPMTiming es verdadero entonces...
    BeatComplete=true;  //BeatComplete es verdadero, es decir que se completa un latido
  }
    
    // Texto en la pantalla oled
  oled.setTextColor(WHITE); //El color del texto será blanco
  oled.setTextSize(2); //El tamaño de texto será 2
  oled.writeFillRect(0,49,128,16,BLACK); //Hacemos un rectangulo negro para que los textos no se superpongan entre cada loop
  oled.setCursor(0,49); //Empezaremos a escribir en coordenada x = 0 y coordenada y = 50 (justo donde inicia el rectangulo anterior)
  if (BPM>30 && BPM < 230){ //condicional para excluir los BPM que esten fuera de una frecuencia cardiaca normal, es decir para excluir falsas lecturas
    oled.print((char)3);  //imprimimos en la pantalla oled el caracter No3 que es un corazón
    oled.print(" ");  //imprimimos en la pantalla oled un espacio en blanco
    oled.print(BPM);  //imprimimos en la pantalla oled el valor de la variable BPM
  } 
  oled.print(" BPM"); // Imprimimos en la pantalla oled un espacio y las siglas BPM
  oled.display(); //función de actualizar la pantalla oled
  x++; // x es igual a x+1, es decir, que le suma 1 a x
}
